选中状态设置
_context = new AIS_InteractiveContext(_viewer);var selectionDrawer = new Prs3d_Drawer();selectionDrawer.SetColor(Colors.Selection);selectionDrawer.SetDisplayMode(1);selectionDrawer.SetTransparency(0.1f);_context.SetSelectionStyle(selectionDrawer);_context.SetHighlightStyle(Prs3d_TypeOfHighlight.Selected, selectionDrawer);_context.SetHighlightStyle(Prs3d_TypeOfHighlight.LocalSelected, selectionDrawer);_context.SetHighlightStyle(Prs3d_TypeOfHighlight.SubIntensity, selectionDrawer);var hilightLocalDrawer = new Prs3d_Drawer();hilightLocalDrawer.SetColor(Colors.Highlight);hilightLocalDrawer.SetDisplayMode(1);_context.SetHighlightStyle(Prs3d_TypeOfHighlight.LocalDynamic, hilightLocalDrawer);
其中,selectionDrawer 是设置鼠标点击选中颜色和样式,hilightLocalDrawer 是设置鼠标移动选中的颜色样式。
选择选中类型
在添加模型后使用 _context 的 Activate()函数才有作用
向场景添加 一个立方体 和 球 模型,在Display后进行选择模式设置,这样对立方体进行Face 选择,对球进行Wire 选择。还可以在所有模型添加完后整体设置
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.WIRE));
这样在之前添加的模型都会设置为选中Wire。
// 立方体var box = new BRepPrimAPI_MakeBox(100.0, 100.0, 100.0).Shape();var aisShape = new AIS_Shape(box);//_context.Display(aisShape, true); // 线框_context.Display(aisShape, 1, 2, true,true, PrsMgr_DisplayStatus.AIS_DS_Displayed); // 实体_context.Activate(aisShape, AIS_Shape.SelectionMode(TopAbs_ShapeEnum.FACE));// 球var sphere = new BRepPrimAPI_MakeSphere(new Pnt(100,100,150),30).Shape();var aissphere = new AIS_Shape(sphere);//_context.Display(aissphere, true); // 线框_context.Display(aissphere,1, 3, true, true, PrsMgr_DisplayStatus.AIS_DS_Displayed); // 实体 _context.Activate(aissphere, AIS_Shape.SelectionMode(TopAbs_ShapeEnum.WIRE));// 调整视图_view.FitAll();_view.MustBeResized();_view.Redraw();
1.Shape
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.SHAPE));
2.Face
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.FACE));
3.Wire
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.WIRE));
4.Edge
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.EDGE));
5.Vertex
_context.Activate(AIS_Shape.SelectionMode(TopAbs_ShapeEnum.VERTEX));